using System;
using System.Threading;
using System.Text;

namespace Adders
{


    class Add1
    {
        public int N;
        public int[] TT;
        public int C1 = 0;
        public object AddLock;

        public void AA()
        {
            int x;
            while (TT[0] < N)
            {
                lock (AddLock)
                {
                    x = TT[0];
                    ++x;
                    TT[0] = x;
                    ++C1;
                }

            }
        }
    }

    class Add2
    {
        public int N;
        public int[] TT;
        public int C2 = 0;
        public object AddLock;

        public void AA()
        {
            int x;
            while (TT[0] < N)
            {
                lock (AddLock)
                {
                    x = TT[0];
                    ++x;
                    TT[0] = x;
                    ++C2;
                }

            }
        }
    }
    class Program
    {
        const int N = 100000000;
        public int[] TT;
        object AddLock;

        static void Main(string[] args)
        {
            new Program().Start();
        }

        private void Start()
        {
            Add1 a1 = new Add1();
            Add2 a2 = new Add2();

            Thread j1 = new Thread(new ThreadStart(a1.AA));
            Thread j2 = new Thread(new ThreadStart(a2.AA));

            TT = new int[1];

            a1.TT = TT;
            a2.TT = TT;

            a1.N = N;
            a2.N = N;

            TT[0] = 0;

            AddLock = new Object();
            a1.AddLock = AddLock;
            a2.AddLock = AddLock;


            Console.WriteLine("Start...\n");
            j1.Start();
            j2.Start();

            while (TT[0] < N) ;

            Console.WriteLine("A1 additions      : {0}\n" +
                              "A2 additions      : {1}\n" +
                              "A1 + A2 additions : {2}\n" +
                              "Final Counter     : {3}\n",
                               a1.C1, a2.C2, a1.C1 + a2.C2, TT[0]);
        }
    }



}
