using System;
using System.Collections.Generic;
using System.Text;

namespace Dele
{ 
    public delegate void Funs();
    
    class Process
    {
        public double[] Vector;
        public bool ok = false, empty = true;
     
       
        
        public void Calculate(Funs fu)
        {


            if (empty && fu.Method.Name != "MRead")
                Console.WriteLine("Wektor pusty.");
            else
            {
                ok = true;
                fu();
            }
        }

        public void MRead()
        {
            string str;
            int dl = -1;

            while (dl < 0 || dl > 1000)
            {
                Console.WriteLine("Podaj dugo tablicy [1-1000]: ");
                str = Console.ReadLine();
                dl = int.Parse(str);
            }

            Vector = new double[dl];

            for (int i = 0; i < Vector.Length; ++i)
            {
                Console.Write("Element {0} : ", i);
                str = Console.ReadLine();
                Vector[i] = double.Parse(str);
            }

            empty = false;
        }

        public void MSin()
        {
            for (int i = 0; i < Vector.Length; ++i)
                Vector[i] = Math.Sin(Vector[i]);
        }

        public void  MSqrt()
        {
            for (int i = 0; i < Vector.Length && ok; ++i)
                if (Vector[i] < 0)
                {
                    ok = false;
                    return;
                  
                }
            for (int i = 0; i < Vector.Length; ++i)    
            {
                Vector[i] = Math.Sqrt(Vector[i]);
            }
        }

        public void MAdd()
        {
            double x;
            Console.Write("Podaj warto x : ");
            string str = Console.ReadLine();
            x = double.Parse(str);
            for (int i = 0; i < Vector.Length; ++i)
                Vector[i] += x;
        }

    }
    class Run
    {
             
        private Process proc;
        public Funs[] TabDel = new Funs[4];

        public void Init()
        {
            proc = new Process();
        
            TabDel[0] = new Funs(proc.MRead);
            TabDel[1] = new Funs(proc.MSqrt);
            TabDel[2] = new Funs(proc.MSin);
            TabDel[3] = new Funs(proc.MAdd);
        }
        
        public void Single(int nr)
        {
            proc.Calculate(TabDel[nr]);

            if (!proc.ok)
                Console.WriteLine("Bdne argumenty.");
            else
            {
                Console.WriteLine("");
                for (int i = 0; i < proc.Vector.Length; ++i)
                    Console.WriteLine("Element {0} : {1}", i, proc.Vector[i]);
                Console.WriteLine("");
            }

        }


    }
    class Program
    {

        static void Main(string[] args)
        {
            Run run = new Run();

            string str;
            int nr;
            bool again = true;

            run.Init();

            while(again)
            {
                Console.Write("Wybierz opcj :\n" +
                              " 1 - wczytaj wektor\n" +
                              " 2 - sqrt\n" +
                              " 3 - sin\n" +
                              " 4 - dodaj x\n" +
                              " 0 - koniec \n:");
                str = Console.ReadLine();
                nr = int.Parse(str);
                if (nr == 0)
                    again = false;
                else
                    if (nr >= 1 && nr <= 4)
                        run.Single(nr - 1);
                    else
                        Console.WriteLine("Za opcja.");
            }
        }
    }
}
