﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ewide
{
    struct Komputer
    {
        public double Cena;
        public string Marka;
    }

    class Program
    {
        const int N = 100;

        void Bieg()
        {
            Komputer[] TabKomp = new Komputer[N];
            int ile = 0, licz;
            bool dalej = true;
            char opcja;
            string str;
            double Suma;

            while (dalej)
            {
                Console.Beep();
                Console.Write("\nWybierz opcję [N,W,U,S,Q] : ");
                str = Console.ReadLine();
                Console.Clear();                
                opcja = str[0];

                switch (opcja & 0x5F)
                {
                    case 'N':
                        if (ile == N)
                        {
                            Console.WriteLine("Tablica pełna.");
                            break;
                        }

                        Console.Write("\nPodaj markę komputera : ");
                        TabKomp[ile].Marka = Console.ReadLine();
                        Console.Write("\nPodaj cenę komputera : ");
                        str = Console.ReadLine();
                        TabKomp[ile++].Cena = double.Parse(str);
                        break;
                    case 'W':
                            for (licz = 0; licz < ile; ++ licz)                        
                                Console.WriteLine("{0}. M : {1}, C : {2}",
                                licz, TabKomp[licz].Marka, TabKomp[licz].Cena);
                        break;
                    case 'U':
                        Console.Write("\nPodaj numer komputera : ");
                        str = Console.ReadLine();
                        licz = int.Parse(str);

                        if (licz < 0 || licz >= ile)
                        {
                            Console.WriteLine("Błędny numer komputera.");
                            break;
                        }

                        TabKomp[licz] = TabKomp[ile-- - 1];
                        Console.WriteLine("Usunięto.");
                        break;
                    case 'S':
                        Suma = 0;
                        for (licz = 0; licz < ile; ++licz)  
                            Suma += TabKomp[licz].Cena;
                        Console.WriteLine("Suma cen wszystkich komputerów : {0}", Suma);
                        break;
                    case 'Q':

                        dalej = false;
                        break;

                    default:
                        Console.WriteLine("Zła opcja");
                        break;
                }


            }

        }

        static void Main(string[] args)
        {
            new Program().Bieg();
        }
    }
}
