using System;
using System.Collections;
using System.Text;

namespace Indexer
{
    class Towar
    {
        public string nazwa;
        public double cena;

        public override string ToString()
        {
            return "\n{ " + nazwa + ", " + cena.ToString() + " }";   
        }
    }

    class Kontener
    {
        const int N = 100;

        public double waga, szer, wys;
        public Towar [] towar;

        public Kontener()
        {
            towar = new Towar[N];
            Random rd = new Random((int)DateTime.Now.Ticks);

            for (int i = 0; i < towar.Length; ++i)
                towar[i] = new Towar { nazwa = "T" + i.ToString("D3"), cena = rd.Next(N) };
        }

        public Towar this[int ix]
        {
            get
            {
                if ((ix & 1) == 0)
                    return towar[ix];
                return null;
            }
            set
            {
                if ((ix & 1) == 0)
                    towar[ix] = value;
            }
        }

    }

    

    class Work
    {
        public void Run()
        {
            Towar tt;

            Kontener kk = new Kontener {waga = 1000, szer = 5, wys = 10};

            tt = kk[8];

            if (tt != null)
                Console.WriteLine(tt);
            else
                Console.WriteLine("null");

            kk[8] = new Towar { nazwa = "Gruszki", cena = 430};

            tt = kk[8];

            if (tt != null)
                Console.WriteLine(tt);
            else
                Console.WriteLine("\nnull");

            tt = kk[9];

            if (tt != null)
                Console.WriteLine(tt);
            else
                Console.WriteLine("\nnull");

            Console.WriteLine();


            

            
        }
    }
    
    class Program
    {   
        static void Main(string[] args)
        {
            Work ww = new Work();
            ww.Run();             
        }
    }
}

/*

class Zasobnik
    {
        public int[] dane = new int[100];

        public int this[int ix]
        {
            get { return dane[ix]; }
            set { dane[ix] = value; }
        }
    }
Zasobnik zz = new Zasobnik();

            zz[9] = 15;
 Console.WriteLine(zz[9].ToString());
*/