/*
	C = A * B

*/

using System;
using System.Collections.Generic;
using System.Text;

namespace Ex0
{
    
    class Program
    {
        const int Aw = 2;	// liczba wierszy A
        const int Ak = 3;	// liczba kolumn A
        const int Bw = 3;	// liczba wierszy B
        const int Bk = 2;	// liczba kolumn B

        void Bieg()
        {
            int i, j, m;
            double s = 0.0;
            double[,] A = new double[Aw, Ak],
                      B = new double[Bw, Bk],
                      C = new double[Aw, Bk];
            string str;

            if (Aw != Bk)
            {
                Console.WriteLine("Nieprawidlowe rozmiary.\n");
                return;
            }
            else
            {
                for (i = 0; i < Aw; ++i)
                {
                    for (j = 0; j < Ak; ++j)
                    {
                        Console.WriteLine("A[{0}][{1}] = ", i, j);
                        str = Console.ReadLine();
                        A[i, j] = double.Parse(str);

                    }
                }

                Console.WriteLine();

                for (i = 0; i < Bw; ++i)
                {
                    for (j = 0; j < Bk; ++j)
                    {
                        Console.WriteLine("B[{0}][{1}] = ", i, j);
                        str = Console.ReadLine();
                        B[i, j] = double.Parse(str);
                    }
                }

                for (i = 0; i < Aw; ++i)
                    for (j = 0; j < Bk; ++j)
                    {
                        s = 0.0;
                        for (m = 0; m < Ak; ++m)
                        {
                            s += (A[i, m] * B[m, j]);

                        }
                        C[i, j] = s;
                    }

                Console.WriteLine("\nMacierz A\n");
                for (i = 0; i < Aw; ++i)
                {
                    Console.WriteLine();
                    for (j = 0; j < Ak; ++j)
                        Console.Write("{0,5:F2}\t", A[i, j]);
                }

                Console.WriteLine("\n\nMacierz B\n");
                for (i = 0; i < Bw; ++i)
                {
                    Console.WriteLine();
                    for (j = 0; j < Bk; ++j)
                        Console.Write("{0,5:F2}\t", B[i, j]);
                }


                Console.WriteLine("\n\nMacierz C\n");
                for (i = 0; i < Aw; ++i)
                {
                    Console.WriteLine();
                    for (j = 0; j < Bk; ++j)
                        Console.Write("{0,5:F2}\t", C[i, j]);
                }

                Console.WriteLine("\n");


            }
        }

        static void Main(string[] args)
        {
            new Program().Bieg();
        }
    }
}


