using System;
using System.Collections;
using System.Text;


namespace MulDele
{
    class Calc
    {
        public delegate void Fun(double x);
        
        public void MSin(double x)
        {
            Console.WriteLine("Sin(x)   = {0}", Math.Sin(x));
        }
        public void MCos(double x)
        {
            Console.WriteLine("Cos(x)   = {0}",  Math.Cos(x));
        }
        public void MFloor(double x)
        {
            Console.WriteLine("Floor(x) = {0}",  Math.Floor(x));
        }        
        public Calc(){}
    }

    class Run
    {
        public void Go()
        {
            Calc.Fun d1, d2, d3;
            Calc.Fun Many;

            Calc cc = new Calc();

            d1 = new Calc.Fun(cc.MSin);
            d2 = new Calc.Fun(cc.MCos);
            d3 = new Calc.Fun(cc.MFloor);

            Many = d1 + d2;
            Many(2.45);
            Console.WriteLine();

            Many += d3;
            Many(2.45);
            Console.WriteLine();

            Many -= d1;
            Many(2.45);
            Console.WriteLine();

            Many += cc.MSin;
            Many(2.45);
            Console.WriteLine();


            System.Delegate[] td = Many.GetInvocationList();

            Console.WriteLine(d1.Target.ToString() + "\n");

            foreach (Delegate dk in td)
                Console.WriteLine(((Calc.Fun)dk).Method.ToString());

            Console.WriteLine();
        }
    }
    
    
    class Program
    {            
        static void Main(string[] args)
        {

            new Run().Go();

        }
    }
}
