using System;
using System.Collections;
using System.Text;

namespace CustConv
{
    class Odcinek
    {
        public int X, Y;

        public override string ToString()
        {
            return "\nOdcinek\n{ " + X.ToString() + ", " + Y.ToString() + " }";   
        }

    }

    class Okrg
    {
        public int Sx, Sy, Pr;

        public override string ToString()
        {
            return "\nOkrg\nrodek : { " + Sx.ToString() + ", " + Sy.ToString() + " }" +
                "\nPromie : " + Pr.ToString();
        }


        // konwersja jawna

        public static explicit operator Okrg(Odcinek oo)
        {
            Okrg ok = new Okrg();

            if (oo.X > oo.Y)
            {
                ok.Sx = oo.X;
                ok.Sy = oo.Y;
            }
            else
            {
                ok.Sx = oo.Y;
                ok.Sy = oo.X;
            }
            ok.Pr = Math.Abs(oo.X + oo.Y);

            return ok;

        }

        // konwersja implkowana

/*
        public static implicit operator Okrg(Odcinek oo)
        {
            Okrg ok = new Okrg();

            ok.Sx = oo.X;
            ok.Sy = 0;
            ok.Pr = oo.Y * oo.Y;

            return ok;
      }
*/

    }

    class Work
    {
        public void Run()
        {
            Odcinek od = new Odcinek {X = -7, Y = 3};

            Console.WriteLine(od);

            Okrg oki = (Okrg)od;      // konwersja jawna

            Console.WriteLine(oki);
/*
            Odcinek li = new Odcinek { X= 3, Y = 9};

            Console.WriteLine(li);

            oki = li;                   // konwesja implikowana

            Console.WriteLine(oki);
*/
            Console.WriteLine();

        }
    }
    
    class Program
    {   
        static void Main(string[] args)
        {
            Work ww = new Work();
            ww.Run();             
        }
    }
}
