using System;
using System.Collections.Generic;
using System.Text;

namespace Event
{
    class Reader
    {
        public delegate void Key();

        public event Key Key_A;
        public event Key Key_Z;

        string str;
        
        public char Read()
        {
            Console.WriteLine("Enter any character and press Return : ");
            str = Console.ReadLine();

            if (str[0] == 'A' && Key_A != null) Key_A();
            if (str[0] == 'Z' && Key_Z != null) Key_Z();

            return str[0];
        }
    }

    class First
    {
        Reader rr;
        Reader.Key d1, d2, d3;

        public void Init(ref Reader rd)
        {
            d1 = new Reader.Key(FA1);
            d2 = new Reader.Key(FA2);
            d3 = new Reader.Key(FZ);
            
            rd.Key_A += d1 + d2;
            rd.Key_Z += d3;
            

            rr = rd;
        }

        void FA1()
        {
            Console.WriteLine("Jestem funkcj FA1 z klasy First.");
        }

        void FA2()
        {
            Console.WriteLine("Jestem funkcj FA2 z klasy First.");
        }
        
        void FZ()
        {
            Console.WriteLine("Jestem funkcj FZ z klasy First.");
            rr.Key_A -= d2;
        }

    }


    class Second
    {
        Reader rr;
        Reader.Key p1, p2, p3;

        public void Init(ref Reader rd)
        {
            p1 = new Reader.Key(SA);
            p2 = new Reader.Key(SZ1);
            p3 = new Reader.Key(SZ2);

            rd.Key_A += p1;
            rd.Key_Z += p2 + p3;

            rr = rd;
        }

        void SA()
        {
            Console.WriteLine("Jestem funkcj SA z klasy Second.");         
        }

        void SZ1()
        {
            Console.WriteLine("Jestem funkcj SZ1 z klasy Second."); 
            rr.Key_Z -= p3;
        }

        void SZ2()
        {
            Console.WriteLine("Jestem funkcj SZ2 z klasy Second.");
        }

    }


    class Program
    {
        static void Main(string[] args)
        {
            Reader rd = new Reader();
            First fi = new First();
            Second se = new Second();

            fi.Init(ref rd);
            se.Init(ref rd);

            while (rd.Read() != 'Q') ;

        }
    }
}
