using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Ex0
{
    class Work
    {
        private FileInfo fi = new FileInfo("alfa.txt");

        private FileStream fs;

        private void Show(byte[] Tab, int Size)
        {
            for (int i = 0; i < Size; ++i)
                Console.Write("{0}", (char)Tab[i]);
            Console.WriteLine('\n');
        }

        public void Run()
        {
            byte[] TaBa = new byte[100];
            
            char cc;
            
            Console.WriteLine("{0} : {1} B\n", fi.FullName, fi.Length);

            fs = new FileStream("alfa.txt", FileMode.Open, FileAccess.ReadWrite);
            //fi.Open(FileMode.Open, FileAccess.ReadWrite);

            for (int i = 0; i < fs.Length; ++i)
                TaBa[i] = (byte)fs.ReadByte();

            Show(TaBa, (int)fs.Length);
           

            fs.Seek(-3, SeekOrigin.End);
            cc = (char)fs.ReadByte();
            Console.WriteLine("{0}\n", cc);

            fs.Position = 2;
            cc = (char)fs.ReadByte();
            Console.WriteLine("{0}\n", cc);



            for (int i = 0; i < fs.Length; ++i)
            {
                if (TaBa[i] >= 'a' && TaBa[i] <= 'z')
                    TaBa[i] &=  0x5F;
            }

            fs.Position = 0;
            fs.Write(TaBa, 0, (int)fs.Length);

            fs.Close();
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Work work = new Work();
            work.Run();
            
        }
    }
}
