using System;
using System.Collections;
using System.Text;
using System.Threading;

namespace ParamThread
{
    class AddParams  // klasa argumentu
    {
        public int a, b;
        public AddParams(int numb1, int numb2)
        {
            a = numb1;
            b = numb2;
        }
    }
    
    class Work
    {
        void Add(object data)  // funkcja cieki
        {
            if (data is AddParams)
            {
                AddParams ap = (AddParams)data;

                Console.WriteLine("{0} + {1} is {2}\n",
                    ap.a, ap.b, ap.a + ap.b );

/*
                for (int i = 0; i < 10; ++i)
                {
                    Console.WriteLine("{0} + {1} + {2} is {3}",
                    ap.a, ap.b, i, ap.a + ap.b + i);
                    Thread.Sleep(1000);
                }
*/
            }
        }

        public void Run()
        {
            AddParams ap = new AddParams(10, 10);
            Thread t = new Thread
                      (new ParameterizedThreadStart(Add));

           // t.IsBackground = true;

            t.Start(ap);

            // Wait to let other thread finish.
            Thread.Sleep(5);

            Console.WriteLine("Main over.\n");
        }

        
    }
   

    class Program
    {
        
        
        static void Main(string[] args)
        {
          new Work().Run();                      
        }
    }
}
 