using System;
using System.Threading;


namespace PinterPool
{

     class PoolTest
     {
        static void Main()
        {
            new Work().Run();

        }
     }

     class Printer 
     {
        public int start = 0, howmany = 3;

	    public void PrintNumbers()
	    {
            for (int i = 0; i < howmany; ++i)
            {
                Console.WriteLine((i + start).ToString() + ", ");
                Thread.Sleep(100);
            }
        }

        
     }
     class Work
     {
         public void Run()
         {
            Printer [] prin = {new Printer(){start = 0, howmany = 5},
                               new Printer(){start = 10, howmany = 25},
                               new Printer(){start = 100, howmany = 7}};
            
             WaitCallback workItem = newWaitCallback(PrintTheNumbers);

            for (int i = 0; i < 3; i++)
                ThreadPool.QueueUserWorkItem(workItem, prin[i]);

            Thread.Sleep(3000);
         }

//
        void PrintTheNumbers(object state)
        {
            Printer task = (Printer)state;
            task.PrintNumbers();    
        }
      }

     }

    
