using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;

using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Xml.Serialization;

using System.IO;

namespace Seria
{
    [Serializable]
public class Radio
{	
	public string Make ;
	[NonSerialized]
	private int something ;
	public  bool On;  
}

    [Serializable]
public class Car
{	public Radio radio = new Radio ( ) ;
	public string PetName ;
	public long Price ;   
}
    [Serializable]
public class WarCar : Car
{
    public int Guns;
}


    [Serializable]
public class Disk
{
    public string Make;
    [NonSerialized]
    private int something;
    public bool SATA;
}
    [Serializable]
public class Computer
{
    public Disk disk = new Disk();
    public long Price;
}

    [Serializable]
public class Laptop : Computer
{
    public double Weight;
}




    class Program
    {   
        void Run()
        {

            FileStream data = File.Create ("Car.dat");

            BinaryFormatter bifoter = new BinaryFormatter();
//
            WarCar cc = new WarCar ( ) ;
            cc.radio.Make = "Aiwa" ;
            cc.radio.On = true ;
            cc.PetName = "Taran" ;
            cc.Price = 127 ;
            cc.Guns = 5;
//
            bifoter.Serialize( data , cc ) ;
            data.Close ( ) ;
//
            data = File.OpenRead ( "Car.dat" ) ;
            WarCar nn = (WarCar)bifoter.Deserialize(data);

            Console.WriteLine("Car.PetName = {0}, Car.Price = {1}, Car.radio.Make = {2}\n " +
                "Car.radio.On = {3}, Car.Guns = {4}", 
                nn.PetName, nn.Price, nn.radio.Make, nn.radio.On, nn.Guns);
/*
           
            SoapFormatter soter = new SoapFormatter();
            //
            WarCar cc = new WarCar();
            cc.radio.Make = "Aiwa";
            cc.radio.On = true;
            cc.PetName = "Taran";
            cc.Price = 127;
            cc.Guns = 5;
            //
            soter.Serialize(data, cc);
            data.Close();
            //
            data = File.OpenRead("Car.dat");
            WarCar nn = (WarCar)soter.Deserialize(data);

            Console.WriteLine("Car.PetName = {0}, Car.Price = {1}, Car.radio.Make = {2}\n " +
                "Car.radio.On = {3}, Car.Guns = {4}", 
                nn.PetName, nn.Price, nn.radio.Make, nn.radio.On, nn.Guns);
*/

/*

            XmlSerializer xs = new XmlSerializer(typeof (WarCar));
            //
            WarCar cc = new WarCar();
            cc.radio.Make = "Aiwa";
            cc.radio.On = true;
            cc.PetName = "Taran";
            cc.Price = 127;
            cc.Guns = 5;
            //
            xs.Serialize(data , cc ) ;
            data.Close();
            //
            data = File.OpenRead("Car.dat");
            WarCar nn = (WarCar)xs.Deserialize(data);

            Console.WriteLine("Car.PetName = {0}, Car.Price = {1}, Car.radio.Make = {2}\n " +
                "Car.radio.On = {3}, Car.Guns = {4}", nn.PetName, nn.Price, nn.radio.Make, nn.radio.On, nn.Guns);
  

*/

/*
            XmlSerializer xs = new XmlSerializer(typeof(Laptop));
            //
            Laptop cc = new Laptop();
            cc.disk.Make = "Maxtor";
            cc.disk.SATA = true;
            
            cc.Price = 127;
            cc.Weight = 5;
            //
            xs.Serialize(data, cc);
           
            data.Close();
            //
            data = File.OpenRead("Car.dat");
            Laptop nn = (Laptop)xs.Deserialize(data);

           
            Console.WriteLine("Laptop.disk.Make = {0}, Laptop.disk.SATA = {1}, Laptop.Price = {2}\n " +
                "Laptop.Weight = {3}", nn.disk.Make, nn.disk.SATA, nn.Price, nn.Weight);

*/


        }
        static void Main(string[] args)
        {
            new Program().Run();
        }
    }
}
