using System;
using System.Collections;
using System.Text;

namespace SortP
{
    class Nazwa : IComparable
    {
        public string Tekst;

        public Nazwa(string tt)
        {
            Tekst = tt;
        }

        public int CompareTo(object obj)        // this.CompareTo(obj)       
         {    
            Nazwa nn = (Nazwa)obj;              // this > obj -> 1 : min -> max

            if (this.Tekst.Length > nn.Tekst.Length) 
                return 1;
            
            if (this.Tekst.Length < nn.Tekst.Length)
                return -1;
            
            return 0;
        }

    }

    class Program
    {
        static void Main(string[] args)
        {
            new Program().Start();
        }

        private void Start()
        {
            ArrayList AA = new ArrayList();

            AA.Add(new Nazwa("Londyn"));
            AA.Add(new Nazwa("Nicea"));
            AA.Add(new Nazwa("Pozna"));
            AA.Add(new Nazwa("Gniezno"));
            AA.Add(new Nazwa("Rzym"));
            AA.Add(new Nazwa("Konstantynopol"));
            AA.Add(new Nazwa("Praga"));
            AA.Add(new Nazwa("Budapeszt"));

            AA.Sort();

            for (int i = 0; i < AA.Count; ++i)
                Pokaz(i, AA[i]);

            Console.WriteLine("\n");        
        }

        void Pokaz(int i, object obj)
        {
            Nazwa nn = (Nazwa)obj;
            Console.WriteLine("Nazwa {0} : Tekst - {1}", i, nn.Tekst);
        }
    }
}
